
export const getRes = (path, type): Promise<any> => {
    return new Promise((resolve, reject) => {
        // const existRes = cc.loader.getRes(path);
        // if (existRes) resolve(existRes);
        // else {
        cc.loader.loadRes(path, type, (err, res) => {
            if (res) {
                resolve(res);
            } else {
                reject(`loadRes faild:${err}`);
            }
        });
        // }
    });
}

export const setGradeIcon = async (division: number, divisionLevel: number, prefix: string = '') => {
    prefix = prefix ? prefix + '-' : '';
    const dJson = getDivision(division, divisionLevel);
    return await getRes(`${prefix}${dJson.icon}`, cc.SpriteFrame);
};

export const setRank = (rank: number, rankLabel: cc.Label) => {
    if (rank) {
        switch (rank) {
            case 1:
                rankLabel.string = 'F';
                break;
            case 2:
                rankLabel.string = 'S';
                break;
            case 3:
                rankLabel.string = 'T';
                break;
            default:
                rankLabel.string = `${rank}`;
                break;
        }
    } else {
        rankLabel.string = 'N';
    }
}
export const createImage = (avatarUrl, head: cc.Sprite) => {
    if (!avatarUrl) return;
    if (CC_WECHATGAME) {
        try {
            let image = wx.createImage();
            image.onload = () => {
                try {
                    let texture = new cc.Texture2D();
                    texture.initWithElement(image);
                    texture.handleLoadedTexture();
                    head.spriteFrame = new cc.SpriteFrame(texture);
                } catch (e) {
                    cc.log(e);
                    head.node.active = false;
                }
            };
            image.src = avatarUrl;
        } catch (e) {
            cc.log(e);
            head.node.active = false;
        }

        // cc.loader.load({
        //     url: avatarUrl, type: 'png'
        // }, (err, texture) => {
        //     if (err) console.error(err);
        //     console.log(texture);
        //     head.spriteFrame = new cc.SpriteFrame(texture);
        // });
    }
}
export const setText = (node: cc.Node, name: string, text: string) => {
    const temp = node.getChildByName(name);
    const comp = temp.getComponent(cc.Label);
    if (comp) comp.string = text;
    if (temp) temp.active = true;
};

export const getDivision = (division: number, level: number) => {
    // const jsonAsset = getRes('Division', cc.JsonAsset);
    for (const j of divisions) {
        if (j.division === division && j.level === level) return j;
    }
};

export const divisions: any = [
    {
        name: "青铜初级",
        division: 1,
        level: 1,
        totalStar: 1,
        icon: "qt",
        keepStar: true,
        keepDivision: true,
        successor: 0,
        comfortAward: [
            {
                itemId: 2,
                count: 1
            }
        ],
        ignorePrize: true
    },
    {
        name: "青铜中级",
        division: 1,
        level: 2,
        totalStar: 2,
        icon: "qt",
        keepStar: true,
        keepDivision: true,
        successor: 0,
        comfortAward: [
            {
                itemId: 2,
                count: 1
            }
        ]
    },
    {
        name: "白银初级",
        division: 2,
        level: 1,
        totalStar: 3,
        icon: "by",
        keepDivision: true,
        successor: 1,
        comfortAward: [
            {
                itemId: 2,
                count: 1
            }
        ]
    },
    {
        name: "白银中级",
        division: 2,
        level: 2,
        totalStar: 3,
        icon: "by",
        keepDivision: true,
        successor: 2,
        comfortAward: [
            {
                itemId: 2,
                count: 1
            }
        ]
    },
    {
        name: "白银高级",
        division: 2,
        level: 3,
        totalStar: 3,
        icon: "by",
        keepDivision: true,
        successor: 2,
        comfortAward: [
            {
                itemId: 2,
                count: 1
            }
        ]
    },
    {
        name: "黄金初级",
        division: 3,
        level: 1,
        totalStar: 4,
        icon: "hj",
        successor: 3,
        comfortAward: [
            {
                itemId: 2,
                count: 2
            },
            {
                itemId: 1,
                count: 50
            }
        ]
    },
    {
        name: "黄金中级",
        division: 3,
        level: 2,
        totalStar: 4,
        icon: "hj",
        successor: 3,
        comfortAward: [
            {
                itemId: 2,
                count: 2
            },
            {
                itemId: 1,
                count: 50
            }
        ]
    },
    {
        name: "黄金高级",
        division: 3,
        level: 3,
        totalStar: 4,
        icon: "hj",
        successor: 4,
        comfortAward: [
            {
                itemId: 2,
                count: 2
            },
            {
                itemId: 1,
                count: 50
            }
        ]
    },
    {
        name: "铂金初级",
        division: 4,
        level: 1,
        totalStar: 5,
        icon: "bj",
        successor: 5,
        comfortAward: [
            {
                itemId: 2,
                count: 5
            },
            {
                itemId: 1,
                count: 100
            }
        ]
    },
    {
        name: "铂金中级",
        division: 4,
        level: 2,
        totalStar: 5,
        icon: "bj",
        successor: 5,
        comfortAward: [
            {
                itemId: 2,
                count: 5
            },
            {
                itemId: 1,
                count: 100
            }
        ]
    },
    {
        name: "铂金高级",
        division: 4,
        level: 3,
        totalStar: 5,
        icon: "bj",
        successor: 6,
        comfortAward: [
            {
                itemId: 2,
                count: 5
            },
            {
                itemId: 1,
                count: 100
            }
        ]
    },
    {
        name: "铂金大师",
        division: 4,
        level: 4,
        totalStar: 5,
        icon: "bj",
        successor: 6,
        comfortAward: [
            {
                itemId: 2,
                count: 5
            },
            {
                itemId: 1,
                count: 100
            }
        ]
    },
    {
        name: "钻石初级",
        division: 5,
        level: 1,
        totalStar: 5,
        icon: "zs",
        successor: 7,
        comfortAward: [
            {
                itemId: 2,
                count: 8
            },
            {
                itemId: 1,
                count: 200
            }
        ]
    },
    {
        name: "钻石中级",
        division: 5,
        level: 2,
        totalStar: 5,
        icon: "zs",
        successor: 8,
        comfortAward: [
            {
                itemId: 2,
                count: 8
            },
            {
                itemId: 1,
                count: 200
            }
        ]
    },
    {
        name: "钻石高级",
        division: 5,
        level: 3,
        totalStar: 5,
        icon: "zs",
        successor: 8,
        comfortAward: [
            {
                itemId: 2,
                count: 8
            },
            {
                itemId: 1,
                count: 200
            }
        ]
    },
    {
        name: "钻石大师",
        division: 5,
        level: 4,
        totalStar: 5,
        icon: "zs",
        successor: 9,
        comfortAward: [
            {
                itemId: 2,
                count: 8
            },
            {
                itemId: 1,
                count: 200
            }
        ]
    },
    {
        name: "星耀初级",
        division: 6,
        level: 1,
        totalStar: 5,
        icon: "xy",
        successor: 9,
        comfortAward: [
            {
                itemId: 2,
                count: 10
            },
            {
                itemId: 1,
                count: 300
            }
        ]
    },
    {
        name: "星耀中级",
        division: 6,
        level: 2,
        totalStar: 5,
        icon: "xy",
        successor: 10,
        comfortAward: [
            {
                itemId: 2,
                count: 10
            },
            {
                itemId: 1,
                count: 300
            }
        ]
    },
    {
        name: "星耀高级",
        division: 6,
        level: 3,
        totalStar: 5,
        icon: "xy",
        successor: 10,
        comfortAward: [
            {
                itemId: 2,
                count: 10
            },
            {
                itemId: 1,
                count: 300
            }
        ]
    },
    {
        name: "星耀大师",
        division: 6,
        level: 4,
        totalStar: 5,
        icon: "xy",
        successor: 11,
        comfortAward: [
            {
                itemId: 2,
                count: 10
            },
            {
                itemId: 1,
                count: 300
            }
        ]
    },
    {
        name: "星耀传说",
        division: 6,
        level: 5,
        totalStar: 5,
        icon: "xy",
        successor: 12,
        comfortAward: [
            {
                itemId: 2,
                count: 10
            },
            {
                itemId: 1,
                count: 300
            }
        ]
    },
    {
        name: "王者",
        division: 7,
        level: 0,
        icon: "wz",
        successor: [
            {
                maxStar: 10,
                toDivision: 12
            },
            {
                maxStar: 20,
                toDivision: 13
            },
            {
                maxStar: 50,
                toDivision: 14
            },
            {
                maxStar: 100,
                toDivision: 15
            },
            {
                maxStar: 999999,
                toDivision: 16
            }
        ],
        comfortAward: [
            {
                itemId: 2,
                count: 15
            },
            {
                itemId: 1,
                count: 500
            }
        ]
    }
];